import json

from typing import Optional
from .pathutils import *
from .secrets import *

__all__ = (
    "BeautifulJSON"
)

class BeautifulJSON:
    @staticmethod
    def BeautifulDict(object: dict, indents: Optional[int] = None):
        if indents:
            result = json.dumps(object, indent=indents)
            return result
        else:
            result = json.dumps(object, indent=4)
            return result

    @staticmethod
    def BeautifulJson(path: StrOrBytesPath, savepath: StrOrBytesPath, indents: Optional[int] = None):
        if exists(savepath):
            raise FileExistsError("File already exists.")
        if indents:
            with open(path, "r", encoding="utf8") as jsonObject:
                _parsedjsonData = json.load(jsonObject)

            with open(savepath, "w", encoding="utf8") as f:
                json.dump(_parsedjsonData, f, indent=indents)
                return
        else:
            with open(path, "r", encoding="utf8") as jsonObject:
                _parsedjsonData = json.load(jsonObject)

            with open(savepath, "w", encoding="utf8") as f:
                json.dump(_parsedjsonData, f, indent=4)
                return

    @staticmethod
    def SearchJson(path: StrOrBytesPath, key: str):
        if not exists(path):
            raise FileNotFoundError("File not found.")
        
        with open(path, "r") as targetObject:
            data = json.load(targetObject)

        return data[key]
