import base64, json

from .pathutils import exists
from .utils import is_json

def encryptDict(object: dict):
    data = json.dumps(object)

    result = base64.b64encode(data.encode("utf8"))
    return result.decode("utf8")


def decryptDict(object: bytes):
    result = base64.b64decode(bytes(object, encoding="utf8"))

    return result.decode("utf8")

def encryptJson(path: str, savepath: str):
    if exists(savepath):
        raise FileExistsError("File already exists. ")
    with open(path, "r") as target:
        if is_json(path):
            data = json.load(target)
        else:
            data = target.read()

    result = base64.b64encode(bytes(data.encode("utf8")))

    with open(savepath, "w") as target_object:
        if is_json(savepath):
            json.dump(result.decode("utf8"), target_object)
        else:
            target_object.write(result.decode("utf8"))

    return

def decryptJson(path: str, savepath: str):
    if exists(savepath):
        raise FileExistsError("File already exists.")
    with open(path, "r") as target:
        if is_json(path):
            data = json.load(target)
        else:
            data = target.read()

    result = base64.b64decode(data.encode("utf8"))

    with open(savepath, "w") as target_object:
        if is_json(savepath):
            json.dump(result.decode("utf8"), target_object)
        else:
            target_object.write(result.decode("utf8"))

    return